from pydantic import BaseModel, EmailStr
from pydantic_mongo import AbstractRepository, ObjectIdField
from datetime import datetime, date
from pydantic.networks import IPvAnyAddress

class IpAddress(BaseModel):
    id: ObjectIdField = None
    username: str
    ip: IPvAnyAddress
    socialnetwork: List[str] | None = None
    status: int = 0
    created_at: datetime = datetime.today()
    updated_at: datetime | None = None
    deleted_at: datetime | None = None
    disabled_at: datetime | None = None

class IpAddressOut(BaseModel):
    id: ObjectIdField = None
    username: str
    ip: IPvAnyAddress
    socialnetwork: List[str] | None = None
    status: int = 0

class IpAddressIn(BaseModel):
    username: str
    ip: IPvAnyAddress
    socialnetwork: List[str] | None = None
    status: int = 0


class IpAddressIDS(BaseModel):
    ids: list[str]


class IpAddressRepository(AbstractRepository[IpAdress]):
    class Meta:
        collection_name = "ipaddress"